//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  LimeGreen
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

extern string TimeFrame       = "Current time frame";
extern int    Stoch1KPeriod   =  300;
extern int    Stoch1Slowing   =    3;
extern int    Stoch1Price     =    0;
extern int    Stoch2KPeriod   =  600;
extern int    Stoch2Slowing   =    3;
extern int    Stoch2Price     =    0;
extern int    NormalizeDigits =    5;
extern double LevelUp         =   80;
extern double LevelDown       =   20;
extern bool   LevelRetraceCross = true;


extern bool   verticalLinesVisible   = false;
extern string verticalLinesID        = "StochLines";
extern color  verticalLinesInColor   = Gold;
extern color  verticalLinesOutColor  = DeepSkyBlue;
extern int    verticalLinesStyle     = STYLE_DOT;
extern int    verticalLinesWidth     = 0;

//
//
//
//
//

double histup[];
double histdn[];
double stoch1[];
double stoch2[];
double cross[];
double state[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
    SetIndexBuffer(0,histdn); SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(1,histup); SetIndexStyle(1,DRAW_HISTOGRAM);
    SetIndexBuffer(2,cross);
    SetIndexBuffer(3,state);
    SetIndexBuffer(4,stoch1);
    SetIndexBuffer(5,stoch2);
       SetLevelValue(0,LevelDown);
       SetLevelValue(1,LevelUp);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { stoch1[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   //
   //
   //
   //
   //
   
   for(int i = limit; i >=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      histup[i] = EMPTY_VALUE;
      histdn[i] = EMPTY_VALUE;
      stoch1[i] = NormalizeDouble(iStochastic(NULL,timeFrame,Stoch1KPeriod,1,Stoch1Slowing,MODE_SMA,Stoch1Price,MODE_MAIN,y),NormalizeDigits);
      stoch2[i] = NormalizeDouble(iStochastic(NULL,timeFrame,Stoch2KPeriod,1,Stoch2Slowing,MODE_SMA,Stoch2Price,MODE_MAIN,y),NormalizeDigits);
      cross[i]  = cross[i+1];
         ObjectDelete(verticalLinesID+":"+Time[i]);
         if (stoch1[i]>LevelUp   && stoch2[i]>LevelUp)   cross[i]= 1;
         if (stoch1[i]<LevelDown && stoch2[i]<LevelDown) cross[i]= 1;
         if (stoch1[i]>LevelDown && stoch1[i]<LevelUp &&
             stoch2[i]>LevelDown && stoch2[i]<LevelUp)   cross[i]=0;
         state[i] = state[i+1];
            if (cross[i] ==  0 && cross[i+1] == 1 && (stoch1[i+1]>LevelUp   || stoch2[i+1]>LevelUp  )) state[i] = -1;      
            if (cross[i] ==  0 && cross[i+1] == 1 && (stoch1[i+1]<LevelDown || stoch2[i+1]<LevelDown)) state[i] =  1;      
            if (cross[i] ==  1) state[i]  = 0;
            if (state[i] == -1) histdn[i] = 1;
            if (state[i] ==  1) histup[i] = 1;
         if (cross[i] != cross[i+1])
               if (cross[i] == 1)
                     drawLine(i,verticalLinesInColor );
               else  drawLine(i,verticalLinesOutColor);
   }
   return(0);
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
   string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

